
#include "leaderboard.h"
#include <math.h>



CSteamLeaderboards::CSteamLeaderboards(): 						
 currentLeaderboard_( "" ),		
 feedback_( "" ),
 currentScore_( 0 ),
 currentAction_( 0 )
{
}

void CSteamLeaderboards::FindLeaderboard( const char *pchLeaderboardName , int score)
{
	if (currentAction_ == 0){
		 currentAction_ = 1;
		 currentLeaderboard_ = pchLeaderboardName;
		 currentScore_ = score;

		 SteamAPICall_t hSteamAPICall = SteamUserStats()->FindLeaderboard(pchLeaderboardName);
		 m_callResultFindLeaderboard.Set(hSteamAPICall, this, &CSteamLeaderboards::OnFindLeaderboard);
		 feedback_ = "finding";
	}
}



void CSteamLeaderboards::OnFindLeaderboard( LeaderboardFindResult_t *pCallback,	bool bIOFailure )
{
	// see if we encountered an error during the call
	if ( !pCallback->m_bLeaderboardFound || bIOFailure )
	{
		currentAction_ = 0;
		feedback_ = "notFound";
		return;
	}
	
	CSteamLeaderboards::UploadScore( pCallback->m_hSteamLeaderboard );
	feedback_ = "scoring";
}


bool CSteamLeaderboards::UploadScore( SteamLeaderboard_t leaderb )
{
 SteamAPICall_t hSteamAPICall = SteamUserStats()->UploadLeaderboardScore( leaderb, k_ELeaderboardUploadScoreMethodKeepBest, currentScore_, NULL, 0 );
	
 m_callResultUploadScore.Set(hSteamAPICall, this, &CSteamLeaderboards::OnUploadScore);

 return true;
}


void CSteamLeaderboards::OnUploadScore(LeaderboardScoreUploaded_t *pCallback, bool bIOFailure)
{
	feedback_ = "success";
	if ( !pCallback->m_bSuccess || bIOFailure )
	{
		feedback_ = "failScoring";
	}
	currentAction_ = 0;

}


