#include "gideros.h"
#include "lua.h"
#include "lauxlib.h"
#include "mainf.h"

#include "steam\steam_api.h"
#include "leaderboard.h"


CSteamLeaderboards *g_SteamLeaderboards = new CSteamLeaderboards();


bool connectedToSteam = false;


int init(lua_State *L)
{
		bool succeed = SteamAPI_Init();
 
		if (succeed) {
			connectedToSteam = true;




			unsigned long long a = SteamUser()->GetSteamID().ConvertToUint64();
			char buffer[32];
			_i64toa(a, buffer, 10);
			
			lua_pushboolean(L, true);
			lua_pushstring(L, buffer);

			return 2;

		}
		return 0;
}

//----------------------------------------------------//

int sendScore(lua_State *L)
{
	int score = lua_tonumber(L, -1);
	const char* pchLeaderboardName = lua_tostring(L, -2);

	g_SteamLeaderboards->FindLeaderboard(pchLeaderboardName,score);

	return 0;
}

int setAchievement(lua_State *L)
{
	bool isSet = lua_toboolean(L, -1);
	const char* ID = lua_tostring(L, -2);

	if (isSet){
		SteamUserStats()->SetAchievement(ID);
		SteamUserStats()->StoreStats();
	}else{
		SteamUserStats()->ClearAchievement(ID);
		SteamUserStats()->StoreStats();
	}

	return 0;
}

//----------------------------------------------------//

	
int checkStatus(lua_State *L)
{
	lua_pushstring(L, g_SteamLeaderboards->feedback_);
	lua_pushstring(L, g_SteamLeaderboards->currentLeaderboard_);
	return 2;
}


//----------------------------------------------------//

int enterFrame(lua_State *L)
{
	SteamAPI_RunCallbacks();
	return 0;
}

//----------------------------------------------------//


int loader(lua_State *L)
{
    const luaL_Reg functionlist[] = {
            {"init", init},
            {"sendScore", sendScore},
            {"setAchievement", setAchievement},
            {"checkStatus", checkStatus},
            {"enterFrame", enterFrame},
            {NULL, NULL},
      };
    luaL_register(L, "Gsteam", functionlist);

    return 1;
}
void g_initializePlugin(lua_State* L)
{
    lua_getglobal(L, "package");
    lua_getfield(L, -1, "preload");
 
    lua_pushcfunction(L, loader);
    lua_setfield(L, -2, "gsteam");
 
    lua_pop(L, 2);    
}
void g_deinitializePlugin(lua_State *L)
{
	if(connectedToSteam){
		SteamAPI_Shutdown();
	}
}

REGISTER_PLUGIN("Gsteam", "1.0");